//+------------------------------------------------------------------+
//|                                                  Alert_Cross.mq4 |
//|                                   Copyright 2013, ForexZZH Corp. |
//|                                           http://www.polycomp.ru |
//+------------------------------------------------------------------+
/* << >>
KPeriod -     max High  min Low
DPeriod - ,     (   :
            - Slowing)
Slowing -    (%)  
MA_Metod -    :
 MODE_SMA (0) -    
 MODE_EMA (1) -    
 MODE_SMMA (2)    
 MODE_LWMA (3) -  
 Price_Fast -   ,    
 Price_Slow -   ,    
   :
               PRICE_CLOSE	0	 
               PRICE_OPEN	1	 
               PRICE_HIGH	2	 
               PRICE_LOW	3	 
               PRICE_MEDIAN	4	 , (high+low)/2
               PRICE_TYPICAL	5	 , (high+low+close)/3
               PRICE_WEIGHTED	6	  , (high+low+close+close)/4
               PRICE_VOLUME 7 ,     :
                               [PRICE_MEDIAN(1)*Volume(1)]/Volume(TF)
                              TF- , 1 -  
               PRICE_DISTR_MAX 8      
                                      
               PRICE_DISTR_WEIGH 9 ,    :
                                 [( )*( )]/( )
                                      
                 -    , (high+low)/2 
 TF    - -   
 k     -    
      -                 
 Prn       -      c ,   myFile
           true -                          
           false -  
*/ 
#property copyright "Copyright 2013, ForexZZH Corp."
#property link      "http://www.polycomp.ru"
//#include <lib_Hist.mqh>
//#include <lib_Array.mqh>
#include <libHistogram.mqh>
#include <WinUser32.mqh>
#include <base_Name.mqh>
//------- --------
extern int TF=0;//-  
extern int k=1;
extern int M=1;
//------------------------
extern int KPeriod=200;
extern int DPeriod=50;
extern int Slowing=3;
extern int Shift=0;
extern int Price_Stoch=PRICE_CLOSE;
extern int Price_Max=PRICE_HIGH;
extern int Price_Min=PRICE_LOW;
extern int MA_Metod=MODE_EMA;
//   
bool ref=false;//    . true-, false-
bool prn=false;//  
double Eps=0.0;
datetime newBar=0,
         curCod,
         prevCod;
bool new_Bar=false;
string valuta,
       nameArrow,
       name,
       myFile="Aller-Hist-multyPrice.csv",
       folder_hist="Stochastic\\",// 
       hist_name=   "Hist-multyPrice";//  
string resp[2]={""};
double Hist[]={0.0};
int s,b,nn;
int handle,v,myColor, vSymbol,pos;
int parStoch[13]={0};
/*
   parStoch[]:   
          [1] - KPeriod (  )
          [2] - DPeriod (  )
          [3] - Slowing (  )
          [4] - MA_Metod ( )
          [5] - Price_Stoch
          [6] - Price_Max
          [7] - Price_Min
          [8] - Shift ()
          [9] - nBars (    )
          [10]- levelTop ( )
          [11]- levelCenter ( )
          [12]- levelBottom  ( ) 
*/                   
//+------------------------------------------------------------------+
int init()
  {
   int i,h;
   int res;
   string txt;
       //folder_hist="Stochastic\\";// 
       //hist_name=   "Hist-multyPrice";//  
   valuta=Symbol();
   if(TF==0) TF=Period();
   v=(k+M+3);
   newBar=0;
   ArrayResize(Hist,v);
   curCod=0;
   prevCod=0;
   s=0;
   b=0;
   s=Arrow_Find("Sell");
   b=Arrow_Find("Buy");
   if(s>0 || b>0)
    {//1
     txt="   ! ?";
     res=MessageBox(txt, valuta+" "+string(TF), MB_YESNO|MB_ICONWARNING);
     Print("s=",s,", ","b=",b); 
     if(res == IDYES)
      {//2
       if(s>0) s=Arrow_Del("Sell"); 
       if(b>0) b=Arrow_Del("Buy"); 
      }//2 
    }//1 
   hist_name=folder_hist!="" ? folder_hist+hist_name: hist_name; 
//++++++++   ++++++++++++++++++++++++
          parStoch[1] = KPeriod;// (  )
          parStoch[2] = DPeriod;// (  )
          parStoch[3] = Slowing;// (  )
          parStoch[4] = MA_Metod;// ( )
          parStoch[5] = Price_Stoch;
          parStoch[6] = Price_Max;
          parStoch[7] = Price_Min;
          parStoch[8] = Shift;// ()
 //---    ---------
 for(i=1;;i++)
  {//1  
   name=name_indHistogram(i);
   if(name=="") return(-1);  
   if(name==hist_name) {pos=i; break;}
  }//1 
//----   -------   
     for(s=0;s<v;s++)
      {//a
       switch (pos)
        {//2
         case 1:
         case 2:
          Hist[s]=iCustom(valuta, TF, hist_name, 
          parStoch[1], parStoch[2], parStoch[3],parStoch[4],parStoch[8], 20, 0, s+1);
          break;
         case 3:
         case 4:
          Hist[s]=iCustom(valuta, TF, hist_name, 
          parStoch[1], parStoch[2], parStoch[3],parStoch[4],parStoch[5],
          parStoch[6],parStoch[7],parStoch[8], 20, 0, s+1);
          break;
         case 5:
         case 6:
          Hist[s]=iCustom(valuta, TF, hist_name, 
          parStoch[1], parStoch[2], parStoch[3],parStoch[4],
          parStoch[5],parStoch[8], 20, 0, s+1);
          break;
         case 7:
          Hist[s]=iCustom(valuta, TF, hist_name, 
          parStoch[1], parStoch[3],parStoch[4],parStoch[5],
          parStoch[6],parStoch[7],parStoch[8], 20, double(parStoch[10]),
          double(parStoch[12]),0, s+1);
          break;
         case 8:
          Hist[s]=iCustom(valuta, TF, hist_name, 
          parStoch[1], parStoch[3],parStoch[4],parStoch[5],
          parStoch[6],parStoch[7],parStoch[8],20,double(parStoch[10]),
          double(parStoch[11]),double(parStoch[12]),0, s+1);
          break;
        }//2
       if(Eps>0.0 && MathAbs(Hist[s])<=Eps) Hist[s]=0.0;
       }//a
     nn=Zone_Nul(valuta, TF, Hist, k, M, 0.0, hist_name, parStoch);  
   //===============================================================   
    if(Cross_Up(ref, Hist, M, k, nn)) {resp[0]="Cross_Up";resp[1]="Buy";}
    else if(Cross_Down(ref, Hist, M, k, nn)) {resp[0]="Cross_Down";resp[1]="Sell";}
         else if(Reverse_Up(ref, Hist, M, k, nn)) {resp[0]="Revers_Up";resp[1]="Buy";}
              else if(Reverse_Down(ref, Hist, M, k, nn)) {resp[0]="Revers_Down";resp[1]="Sell";}
                   else {resp[0]="";resp[1]="";}
    if(resp[0]!="")
      {//2
       curCod=iTime(valuta,TF,0);
       newBar=curCod;
       if(curCod != prevCod)
        {//3
         PlaySound("alert.wav");
         res=MessageBox(resp[0]+" "+TimeToStr(curCod, TIME_DATE|TIME_MINUTES),valuta+"_"+string(TF),MB_OK|MB_ICONWARNING);
         prevCod=curCod;
          if(resp[1]=="Buy")
           {vSymbol=225; myColor=Green; b++; nameArrow=resp[1]+string(b);} 
          else 
           {vSymbol=226; myColor=Red; s++; nameArrow=resp[1]+string(s);}
          ObjectCreate(nameArrow, OBJ_ARROW, 0, Time[0], Open[0]);
          ObjectSet(nameArrow, OBJPROP_ARROWCODE, vSymbol);
          ObjectSet(nameArrow, OBJPROP_COLOR, myColor);
        }//3 
      } //2
   if(prn)
   {//1
    h=ArraySize(Hist);
    handle=FileOpen(myFile, FILE_CSV|FILE_READ|FILE_WRITE  , ';');
    FileSeek(handle, 0, SEEK_END );
    FileWrite( handle, TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES),valuta,hist_name); 
    FileWrite( handle,  "Hist");
    for(i=0;i<h;i++) FileWrite( handle,  Hist[i]);
   }//1 
   newBar=iTime(valuta,TF,0);
   return(0);
  }
//+------------------------------------------------------------------+
int start()
  {//w
   int res,
       i;
   new_Bar=false;
   if(isNewBar(newBar, valuta, TF)) new_Bar=true;
   else return(0);
   if(new_Bar)
    {//1
     v=(M+k+nn+2)+1;
     ArrayResize(Hist,v);
     for(i=v-1;i>0;i--) Hist[i]=Hist[i-1];//  1  
     // Hist   
//---------   ----------------
       switch (pos)
        {//2
         case 1:
         case 2:
          Hist[0]=iCustom(valuta, TF, hist_name, 
          parStoch[1], parStoch[2], parStoch[3],parStoch[4],parStoch[8],50, 0, 1);
          break;
         case 3:
         case 4:
          Hist[0]=iCustom(valuta, TF, hist_name, 
          parStoch[1], parStoch[2], parStoch[3],parStoch[4],parStoch[5],
          parStoch[6],parStoch[7],parStoch[8],50, 0, 1);
          break;
         case 5:
         case 6:
          Hist[0]=iCustom(valuta, TF, hist_name, 
          parStoch[1], parStoch[2], parStoch[3],parStoch[4],
          parStoch[5],parStoch[8],50, 0, 1);
          break;
         case 7:
          Hist[0]=iCustom(valuta, TF, hist_name, 
          parStoch[1], parStoch[3],parStoch[4],parStoch[5],
          parStoch[6],parStoch[7],parStoch[8],50, double(parStoch[10]),
          double(parStoch[12]),0, 1);
          break;
         case 8:
          Hist[0]=iCustom(valuta, TF, hist_name, 
          parStoch[1], parStoch[3],parStoch[4],parStoch[5],
          parStoch[6],parStoch[7],parStoch[8],50,double(parStoch[10]),
          double(parStoch[11]),double(parStoch[12]),0, 1);
          break;
        }//2
       if(Eps>0.0 && MathAbs(Hist[0])<=Eps) Hist[0]=0.0;
    nn=Zone_Nul(valuta, TF, Hist, k, M, 0.0, hist_name, parStoch);  
 //------------------------------------------------------------------------- 
    if(Cross_Up(false, Hist, M, k, nn)) {resp[0]="Cross_Up";resp[1]="Buy";}
    else if(Cross_Down(false, Hist, M, k, nn)) {resp[0]="Cross_Down";resp[1]="Sell";}
         else if(Reverse_Up(true, Hist, M, k, nn)) {resp[0]="Revers_Up";resp[1]="Buy";}
              else if(Reverse_Down(true, Hist, M, k, nn)) {resp[0]="Revers_Down";resp[1]="Sell";}
                   else {resp[0]="";resp[1]="";}
    if(resp[0]!="")
      {//2
       curCod=iTime(valuta,TF,0);
       newBar=curCod;
       if(curCod != prevCod)
        {//3
         PlaySound("alert.wav");
         res=MessageBox(resp[0]+" "+TimeToStr(curCod, TIME_DATE|TIME_MINUTES),valuta+"_"+string(TF),MB_OK|MB_ICONWARNING);
         prevCod=curCod;
         if(resp[1]=="Buy")
           {vSymbol=225; myColor=Green; b++; nameArrow=resp[1]+string(b);} 
         else 
           {vSymbol=226; myColor=Red; s++; nameArrow=resp[1]+string(s);}
         ObjectCreate(nameArrow, OBJ_ARROW, 0, Time[0], Open[0]);
         ObjectSet(nameArrow, OBJPROP_ARROWCODE, vSymbol);
         ObjectSet(nameArrow, OBJPROP_COLOR, myColor);
         if(prn) 
         {//4
          FileWrite(handle, TimeToStr(curCod, TIME_DATE|TIME_MINUTES), "TF "+string(TF), resp[0]);
          for(i=0;i<=M+k+nn+1;i++)
          FileWrite(handle, TimeToStr(iTime(valuta,TF,i+1), TIME_DATE|TIME_MINUTES), Hist[i]);
         }//4  
        }//3 
      } //2
    }//1
 //------------------------------------------------------------------------- 
   return(0);
  }
//+------------------------------------------------------------------+
bool isNewBar(datetime& prevTime, string sSymbol, int TimeFrame)
{
   bool res=false;
    
   if (prevTime!=iTime(sSymbol, TimeFrame, 0)) 
      {
         prevTime=iTime(sSymbol, TimeFrame, 0);  
         res=true;
      } 
   return(res);
}
//-------------------------------------------------------------
int Arrow_Del(string name_Arrow)
{
   int m=ObjectsTotal(OBJ_ARROW);
   if(m == 0) return(0);
   for(int i=m;i>=0;i--)
     if(StringFind(ObjectName(i), name_Arrow) >= 0) ObjectDelete( ObjectName(i));
   return(0);
}
//--------------------------------------------------------------
int Arrow_Find(string name_Arrow)
{
   int n=0;
   int m=ObjectsTotal();
   if(m==0) return(0);
   for(int i=m;i>=0;i--)
    {
     if(StringFind(ObjectName(i), name_Arrow) < 0) continue;
     n++;
    }   
   return(n);
}




